#include <future>
#include <iostream>
#include <mutex>
#include <boost/fiber/all.hpp>

using namespace boost::fibers;
using namespace std;
using namespace std::literals;

volatile int a = 0, b = 0;
std::mutex m;

void  suma()
{
	while (true)
	{
		m.lock();
		++a;
		++b;
		m.unlock();
		boost::this_fiber::yield();
	}
}

void resta()
{
	while (true)
	{
		m.lock();
		--a;
		--b;
		m.unlock();
		boost::this_fiber::yield();
	}
}

void muestra()
{
	while (true)
	{
		m.lock();
		cout << "a = " << a << "\t b = " << b << endl;
		m.unlock();
		this_thread::sleep_for(250ms);
		boost::this_fiber::yield();
	}
}

int main()
{
	fiber t[3] = {fiber(suma), fiber(resta), fiber(muestra)};
	for (auto &i: t) i.join();
}
