.ONESHELL:

ATT = $(EXE:=.att)
EXE = $(basename $(SRC))
SRC = $(sort $(wildcard *.cc) $(shell echo sumaresta-O{0,1,2,3,g,s}.cc))

CXXFLAGS = -fanalyzer -g -march=native -O3 -pthread -std=c++20 -Wall
LDFLAGS += -lboost_fiber -lboost_context

all: att
	-@find -mindepth 2 -maxdepth 2 -name makefile -execdir make $@ \;

att: $(ATT)

clean:
	-rm -fv $(ATT) $(EXE) core.* *~
	-find -mindepth 2 -maxdepth 2 -name makefile -execdir make $@ \;

exe: $(EXE)

suma: $(sort $(filter sumaresta%,$(EXE)))
	@for i in $^; do 
		echo $$i; gdb -batch -ex "file $$i" -ex 'disas suma' | c++filt
		echo
	done

%-O0: CXXFLAGS+=-O0
%-O1: CXXFLAGS+=-O1
%-O2: CXXFLAGS+=-O2
%-O3: CXXFLAGS+=-O3
%-Og: CXXFLAGS+=-Og
%-Os: CXXFLAGS+=-Os

%.att: %
	objdump -Cd $< > $@

sumaresta-O%.cc: sumaresta.cc
	ln -sf $< $@

.PHONY: all att clean exe suma
.PRECIOUS: $(SRC)

